/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VVersionRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VVersion extends TableImpl<VVersionRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_version</code>
     */
    public static final VVersion V_VERSION = new VVersion();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VVersionRecord> getRecordType() {
        return VVersionRecord.class;
    }

    /**
     * The column <code>common_dd.v_version.db_version</code>.
     */
    public final TableField<VVersionRecord, Integer> DB_VERSION = createField(DSL.name("db_version"), SQLDataType.INTEGER, this, "");

    private VVersion(Name alias, Table<VVersionRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VVersion(Name alias, Table<VVersionRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_version" as  SELECT 4 AS db_version;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_version</code> table reference
     */
    public VVersion(String alias) {
        this(DSL.name(alias), V_VERSION);
    }

    /**
     * Create an aliased <code>common_dd.v_version</code> table reference
     */
    public VVersion(Name alias) {
        this(alias, V_VERSION);
    }

    /**
     * Create a <code>common_dd.v_version</code> table reference
     */
    public VVersion() {
        this(DSL.name("v_version"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VVersion as(String alias) {
        return new VVersion(DSL.name(alias), this);
    }

    @Override
    public VVersion as(Name alias) {
        return new VVersion(alias, this);
    }

    @Override
    public VVersion as(Table<?> alias) {
        return new VVersion(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(String name) {
        return new VVersion(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(Name name) {
        return new VVersion(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVersion rename(Table<?> name) {
        return new VVersion(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion where(Condition condition) {
        return new VVersion(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVersion where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVersion where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVersion where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVersion where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVersion whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
